<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2 Final//EN">
<html>
<head>
<title>/home/tylerwbrown/Code/Personal/Challenges/Haskell/extra_long_factorial.hs</title>
</head>
<head>
<link type='text/css' rel='stylesheet' href='liquid.css' />
</head>

<body>
<hr>
Put mouse over identifiers to see inferred types
<pre><span class=hs-linenum>1: </span><a class=annot href="#"><span class=annottext>GHC.Types.Module</span><span class='hs-keyword'>module</span></a> <span class='hs-conid'>Main</span> <span class='hs-keyword'>where</span>
<span class=hs-linenum>2: </span>
<span class=hs-linenum>3: </span><a class=annot href="#"><span class=annottext>(GHC.Num.Num p, GHC.Classes.Ord p) =&gt; lq_tmp$x##177:p -&gt; p</span><span class='hs-definition'>factorial</span></a> <a class=annot href="#"><span class=annottext>p</span><span class='hs-varid'>n</span></a>  
<span class=hs-linenum>4: </span>  <span class='hs-keyglyph'>|</span> <a class=annot href="#"><span class=annottext>{lq_tmp$x##202 : GHC.Types.Bool | lq_tmp$x##202 &lt;=&gt; n##anM &lt; lq_anf$##7205759403792804027##d2Ib}</span><span class='hs-varid'>n</span></a> <a class=annot href="#"><span class=annottext>lq_tmp$x##207:{lq_tmp$x##212 : p^"lq_tmp$x##211" | $k_##210[VV##209:=lq_tmp$x##212][lq_tmp$x##206:=fix$36$$36$dOrd_a2d6]} -&gt; lq_tmp$x##208:{lq_tmp$x##212 : p^"lq_tmp$x##211" | $k_##210[VV##209:=lq_tmp$x##212][lq_tmp$x##206:=fix$36$$36$dOrd_a2d6]} -&gt; {lq_tmp$x##202 : GHC.Types.Bool | lq_tmp$x##202 &lt;=&gt; lq_tmp$x##207 &lt; lq_tmp$x##208}</span><span class='hs-varop'>&lt;</span></a> <span class='hs-num'>1</span> <span class='hs-keyglyph'>=</span> <a class=annot href="#"><span class=annottext>{lq_tmp$x##301 : GHC.Integer.Type.Integer | lq_tmp$x##301 == 1}</span><span class='hs-num'>1</span></a>
<span class=hs-linenum>5: </span>  <span class='hs-keyglyph'>|</span> <span class='hs-varid'>otherwise</span> <span class='hs-keyglyph'>=</span> <a class=annot href="#"><span class=annottext>{lq_tmp$x##294 : p^"lq_tmp$x##96" | lq_tmp$x##294 == n##anM}</span><span class='hs-varid'>n</span></a> <a class=annot href="#"><span class=annottext>lq_tmp$x##288:p -&gt; lq_tmp$x##289:p -&gt; {lq_tmp$x##291 : p^"lq_tmp$x##290" | lq_tmp$x##291 == lq_tmp$x##288 * lq_tmp$x##289}</span><span class='hs-varop'>*</span></a> <a class=annot href="#"><span class=annottext>(GHC.Num.Num p, GHC.Classes.Ord p) =&gt; lq_tmp$x##177:p -&gt; p</span><span class='hs-varid'>factorial</span></a> <span class='hs-layout'>(</span><a class=annot href="#"><span class=annottext>{lq_tmp$x##253 : p^"lq_tmp$x##252" | lq_tmp$x##253 == n##anM - lq_anf$##7205759403792804031##d2If}</span><span class='hs-varid'>n</span></a> <a class=annot href="#"><span class=annottext>lq_tmp$x##250:p -&gt; lq_tmp$x##251:p -&gt; {lq_tmp$x##253 : p^"lq_tmp$x##252" | lq_tmp$x##253 == lq_tmp$x##250 - lq_tmp$x##251}</span><span class='hs-comment'>-</span></a> <span class='hs-num'>1</span><span class='hs-layout'>)</span>
<span class=hs-linenum>6: </span>
<span class=hs-linenum>7: </span><a class=annot href="#"><span class=annottext>(GHC.Types.IO {lq_tmp$x##412 : ()^"lq_tmp$x##411" "lq_tmp$x##9" | $k_##410[lq_tmp$x##408:=Main.main][VV##409:=lq_tmp$x##412]})</span><span class='hs-definition'>main</span></a> <span class='hs-keyglyph'>=</span> <span class='hs-keyword'>do</span>
<span class=hs-linenum>8: </span>    <a class=annot href="#"><span class=annottext>GHC.Integer.Type.Integer</span><span class='hs-varid'>n</span></a> <span class='hs-keyglyph'>&lt;-</span> <a class=annot href="#"><span class=annottext>(GHC.Types.IO GHC.Integer.Type.Integer)</span><span class='hs-varid'>readLn</span></a> <span class='hs-keyglyph'>::</span> <span class='hs-conid'>IO</span> <span class='hs-conid'>Integer</span>
<span class=hs-linenum>9: </span>    <a class=annot href="#"><span class=annottext>lq_tmp$x##344:GHC.Integer.Type.Integer -&gt; (GHC.Types.IO ())</span><span class='hs-varid'>print</span></a> <span class='hs-varop'>$</span> <a class=annot href="#"><span class=annottext>lq_tmp$x##361:GHC.Integer.Type.Integer -&gt; GHC.Integer.Type.Integer</span><span class='hs-varid'>factorial</span></a> <span class='hs-varid'>n</span>
</pre>
</body>
</html>